diff --git a/src/mongo/db/pipeline/document_source_change_stream_test.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_change_stream_test.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_test.cpp
index a340096f5e..705527bf9f 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_test.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_test.cpp
@@ -42,20 +42,20 @@
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_invalidate.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
-#include "mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_oplog_match.h"
-#include "mongo/db/pipeline/document_source_change_stream_transform.h"
-#include "mongo/db/pipeline/document_source_change_stream_unwind_transactions.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_transform.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/db/repl/oplog_entry.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_transform.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_change_stream_transform.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.cpp
index 229b922956..c87aa30395 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_transform.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.cpp
@@ -31,17 +31,18 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_transform.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_transform.h"
 
 #include "mongo/db/catalog/collection_catalog.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
 #include "mongo/db/pipeline/change_stream_document_diff_parser.h"
 #include "mongo/db/pipeline/document_path_support.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
-#include "mongo/db/pipeline/document_source_limit.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/expression.h"
-#include "mongo/db/pipeline/lite_parsed_document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_limit.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/resume_token.h"
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/db/repl/bson_extract_optime.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_transform.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.h
similarity index 98%
rename from src/mongo/db/pipeline/document_source_change_stream_transform.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.h
index 46fe08b7a4..fca5639dff 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_transform.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_transform.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.cpp b/src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.cpp
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.cpp
index 7f3b20b0e6..b978c1cd30 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.cpp
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_unwind_transactions.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h"
 
 #include "mongo/db/query/query_feature_flags_gen.h"
 #include "mongo/db/transaction_history_iterator.h"
diff --git a/src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.h b/src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.h
rename to src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h
index ba71e5b6be..e673e01a07 100644
--- a/src/mongo/db/pipeline/document_source_change_stream_unwind_transactions.h
+++ b/src/mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/change_stream_helpers_legacy.cpp b/src/mongo/db/pipeline/change_stream_helpers_legacy.cpp
index 0fff6070ba..cbdafe8f10 100644
--- a/src/mongo/db/pipeline/change_stream_helpers_legacy.cpp
+++ b/src/mongo/db/pipeline/change_stream_helpers_legacy.cpp
@@ -31,18 +31,18 @@
 
 #include "mongo/db/pipeline/change_stream_helpers_legacy.h"
 
-#include "mongo/db/pipeline/document_source_change_stream_check_invalidate.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_topology_change.h"
-#include "mongo/db/pipeline/document_source_change_stream_close_cursor.h"
-#include "mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h"
-#include "mongo/db/pipeline/document_source_change_stream_handle_topology_change.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_post_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_lookup_pre_image.h"
-#include "mongo/db/pipeline/document_source_change_stream_oplog_match.h"
-#include "mongo/db/pipeline/document_source_change_stream_transform.h"
-#include "mongo/db/pipeline/document_source_change_stream_unwind_transactions.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_invalidate.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_close_cursor.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_handle_topology_change.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_post_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_lookup_pre_image.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_oplog_match.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_transform.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_unwind_transactions.h"
+#include "mongo/db/pipeline/expression/expression.h"
 
 namespace mongo {
 namespace change_stream_legacy {
diff --git a/src/mongo/db/pipeline/change_stream_helpers_legacy.h b/src/mongo/db/pipeline/change_stream_helpers_legacy.h
index 4c790782a2..d00cbe940f 100644
--- a/src/mongo/db/pipeline/change_stream_helpers_legacy.h
+++ b/src/mongo/db/pipeline/change_stream_helpers_legacy.h
@@ -27,8 +27,8 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/document_source_change_stream.h"
-#include "mongo/db/pipeline/document_source_change_stream_gen.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_gen.h"
 
 namespace mongo::change_stream_legacy {
 
diff --git a/src/mongo/db/pipeline/document_source.cpp b/src/mongo/db/pipeline/document_source/document_source.cpp
similarity index 96%
rename from src/mongo/db/pipeline/document_source.cpp
rename to src/mongo/db/pipeline/document_source/document_source.cpp
index 997f8c1f06..fb989b03c1 100644
--- a/src/mongo/db/pipeline/document_source.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source.cpp
@@ -29,16 +29,16 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 #include "mongo/db/commands/feature_compatibility_version_documentation.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/matcher/expression_algo.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_internal_shard_filter.h"
-#include "mongo/db/pipeline/document_source_match.h"
-#include "mongo/db/pipeline/document_source_sample.h"
-#include "mongo/db/pipeline/document_source_sequential_document_cache.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_internal_shard_filter.h"
+#include "mongo/db/pipeline/document_source/document_source_match.h"
+#include "mongo/db/pipeline/document_source/document_source_sample.h"
+#include "mongo/db/pipeline/document_source/document_source_sequential_document_cache.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/field_path.h"
 #include "mongo/db/pipeline/semantic_analysis.h"
diff --git a/src/mongo/db/pipeline/document_source_add_fields.cpp b/src/mongo/db/pipeline/document_source/document_source_add_fields.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_add_fields.cpp
rename to src/mongo/db/pipeline/document_source/document_source_add_fields.cpp
index ec245402c2..eee9a027e6 100644
--- a/src/mongo/db/pipeline/document_source_add_fields.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_add_fields.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
 
 #include <boost/optional.hpp>
 #include <boost/smart_ptr/intrusive_ptr.hpp>
diff --git a/src/mongo/db/pipeline/document_source_add_fields.h b/src/mongo/db/pipeline/document_source/document_source_add_fields.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_add_fields.h
rename to src/mongo/db/pipeline/document_source/document_source_add_fields.h
index 49cb228c73..87a9a09da6 100644
--- a/src/mongo/db/pipeline/document_source_add_fields.h
+++ b/src/mongo/db/pipeline/document_source/document_source_add_fields.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_add_fields_test.cpp b/src/mongo/db/pipeline/document_source/document_source_add_fields_test.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_add_fields_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_add_fields_test.cpp
index 9d3227f841..28834c3b06 100644
--- a/src/mongo/db/pipeline/document_source_add_fields_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_add_fields_test.cpp
@@ -35,9 +35,9 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_add_fields.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_add_fields.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/unittest/unittest.h"
 #include "mongo/util/assert_util.h"
 
diff --git a/src/mongo/db/pipeline/document_source_bucket.cpp b/src/mongo/db/pipeline/document_source/document_source_bucket.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_bucket.cpp
rename to src/mongo/db/pipeline/document_source/document_source_bucket.cpp
index 5fe098ae41..04bc9b30b5 100644
--- a/src/mongo/db/pipeline/document_source_bucket.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket.cpp
@@ -27,11 +27,11 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/document_source_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_bucket.h"
 
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_sort.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_bucket.h b/src/mongo/db/pipeline/document_source/document_source_bucket.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_bucket.h
rename to src/mongo/db/pipeline/document_source/document_source_bucket.h
index 7ac16dbdd7..7e3356d060 100644
--- a/src/mongo/db/pipeline/document_source_bucket.h
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_bucket_auto.cpp b/src/mongo/db/pipeline/document_source/document_source_bucket_auto.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_bucket_auto.cpp
rename to src/mongo/db/pipeline/document_source/document_source_bucket_auto.cpp
index 6163056596..30a4a66fdd 100644
--- a/src/mongo/db/pipeline/document_source_bucket_auto.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket_auto.cpp
@@ -29,9 +29,9 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_bucket_auto.h"
+#include "mongo/db/pipeline/document_source/document_source_bucket_auto.h"
 
-#include "mongo/db/pipeline/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 #include "mongo/db/stats/resource_consumption_metrics.h"
 
diff --git a/src/mongo/db/pipeline/document_source_bucket_auto.h b/src/mongo/db/pipeline/document_source/document_source_bucket_auto.h
similarity index 96%
rename from src/mongo/db/pipeline/document_source_bucket_auto.h
rename to src/mongo/db/pipeline/document_source/document_source_bucket_auto.h
index 44bd1e3f8f..c43ac60f38 100644
--- a/src/mongo/db/pipeline/document_source_bucket_auto.h
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket_auto.h
@@ -29,10 +29,10 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/accumulation_statement.h"
-#include "mongo/db/pipeline/accumulator.h"
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/expression.h"
+#include "mongo/db/pipeline/accumulator/accumulation_statement.h"
+#include "mongo/db/pipeline/accumulator/accumulator.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/expression/expression.h"
 #include "mongo/db/pipeline/granularity_rounder.h"
 #include "mongo/db/sorter/sorter.h"
 
diff --git a/src/mongo/db/pipeline/document_source_bucket_auto_test.cpp b/src/mongo/db/pipeline/document_source/document_source_bucket_auto_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_bucket_auto_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_bucket_auto_test.cpp
index 5bcad8dc0b..99caa476a0 100644
--- a/src/mongo/db/pipeline/document_source_bucket_auto_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket_auto_test.cpp
@@ -43,9 +43,9 @@
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
 #include "mongo/db/pipeline/dependencies.h"
-#include "mongo/db/pipeline/document_source_bucket_auto.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_bucket_auto.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/unittest/temp_dir.h"
 #include "mongo/unittest/unittest.h"
 
diff --git a/src/mongo/db/pipeline/document_source_bucket_test.cpp b/src/mongo/db/pipeline/document_source/document_source_bucket_test.cpp
similarity index 97%
rename from src/mongo/db/pipeline/document_source_bucket_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_bucket_test.cpp
index 7d540383e9..da12022e71 100644
--- a/src/mongo/db/pipeline/document_source_bucket_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_bucket_test.cpp
@@ -39,10 +39,10 @@
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/exec/document_value/value_comparator.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_bucket.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_mock.h"
-#include "mongo/db/pipeline/document_source_sort.h"
+#include "mongo/db/pipeline/document_source/document_source_bucket.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
+#include "mongo/db/pipeline/document_source/document_source_sort.h"
 #include "mongo/unittest/unittest.h"
 
 namespace mongo {
diff --git a/src/mongo/db/pipeline/document_source_check_resume_token_test.cpp b/src/mongo/db/pipeline/document_source/document_source_check_resume_token_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_check_resume_token_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_check_resume_token_test.cpp
index 9c470320d9..a66447e3a4 100644
--- a/src/mongo/db/pipeline/document_source_check_resume_token_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_check_resume_token_test.cpp
@@ -40,9 +40,9 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/plan_stats.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_change_stream_check_resumability.h"
-#include "mongo/db/pipeline/document_source_change_stream_ensure_resume_token_present.h"
-#include "mongo/db/pipeline/document_source_mock.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_check_resumability.h"
+#include "mongo/db/pipeline/change_stream/document_source_change_stream_ensure_resume_token_present.h"
+#include "mongo/db/pipeline/document_source/document_source_mock.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/db/pipeline/resume_token.h"
diff --git a/src/mongo/db/pipeline/document_source_coll_stats.cpp b/src/mongo/db/pipeline/document_source/document_source_coll_stats.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_coll_stats.cpp
rename to src/mongo/db/pipeline/document_source/document_source_coll_stats.cpp
index e7c9681d88..3a43d78bb7 100644
--- a/src/mongo/db/pipeline/document_source_coll_stats.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_coll_stats.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_coll_stats.h"
+#include "mongo/db/pipeline/document_source/document_source_coll_stats.h"
 
 #include "mongo/bson/bsonobj.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
diff --git a/src/mongo/db/pipeline/document_source_coll_stats.h b/src/mongo/db/pipeline/document_source/document_source_coll_stats.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_coll_stats.h
rename to src/mongo/db/pipeline/document_source/document_source_coll_stats.h
index 72c6923ccd..01e05a7ffa 100644
--- a/src/mongo/db/pipeline/document_source_coll_stats.h
+++ b/src/mongo/db/pipeline/document_source/document_source_coll_stats.h
@@ -29,8 +29,8 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
-#include "mongo/db/pipeline/document_source_coll_stats_gen.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source_coll_stats_gen.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_coll_stats.idl b/src/mongo/db/pipeline/document_source/document_source_coll_stats.idl
similarity index 97%
rename from src/mongo/db/pipeline/document_source_coll_stats.idl
rename to src/mongo/db/pipeline/document_source/document_source_coll_stats.idl
index 060c20d835..504fedb3fa 100644
--- a/src/mongo/db/pipeline/document_source_coll_stats.idl
+++ b/src/mongo/db/pipeline/document_source/document_source_coll_stats.idl
@@ -29,7 +29,7 @@
 global:
   cpp_namespace: "mongo"
   cpp_includes:
-    - "mongo/db/pipeline/document_source_parsing_validators.h"
+    - "mongo/db/pipeline/document_source/document_source_parsing_validators.h"
 
 imports:
   - "mongo/idl/basic_types.idl"
diff --git a/src/mongo/db/pipeline/document_source_count.cpp b/src/mongo/db/pipeline/document_source/document_source_count.cpp
similarity index 94%
rename from src/mongo/db/pipeline/document_source_count.cpp
rename to src/mongo/db/pipeline/document_source/document_source_count.cpp
index 988bf414da..ecfb465e84 100644
--- a/src/mongo/db/pipeline/document_source_count.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_count.cpp
@@ -29,11 +29,11 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_count.h"
+#include "mongo/db/pipeline/document_source/document_source_count.h"
 
 #include "mongo/db/jsobj.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_project.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_project.h"
 #include "mongo/db/pipeline/expression_context.h"
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
diff --git a/src/mongo/db/pipeline/document_source_count.h b/src/mongo/db/pipeline/document_source/document_source_count.h
similarity index 97%
rename from src/mongo/db/pipeline/document_source_count.h
rename to src/mongo/db/pipeline/document_source/document_source_count.h
index 5abc4bfca6..8f3fb8e1c3 100644
--- a/src/mongo/db/pipeline/document_source_count.h
+++ b/src/mongo/db/pipeline/document_source/document_source_count.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_count_test.cpp b/src/mongo/db/pipeline/document_source/document_source_count_test.cpp
similarity index 95%
rename from src/mongo/db/pipeline/document_source_count_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_count_test.cpp
index 9ffd8a6d12..43ceb737ad 100644
--- a/src/mongo/db/pipeline/document_source_count_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_count_test.cpp
@@ -40,9 +40,9 @@
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/exec/document_value/value.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_count.h"
-#include "mongo/db/pipeline/document_source_group.h"
-#include "mongo/db/pipeline/document_source_single_document_transformation.h"
+#include "mongo/db/pipeline/document_source/document_source_count.h"
+#include "mongo/db/pipeline/document_source/document_source_group.h"
+#include "mongo/db/pipeline/document_source/document_source_single_document_transformation.h"
 
 namespace mongo {
 namespace {
diff --git a/src/mongo/db/pipeline/document_source_current_op.cpp b/src/mongo/db/pipeline/document_source/document_source_current_op.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_current_op.cpp
rename to src/mongo/db/pipeline/document_source/document_source_current_op.cpp
index da1dda8022..7882cd61f6 100644
--- a/src/mongo/db/pipeline/document_source_current_op.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_current_op.cpp
@@ -29,7 +29,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_current_op.h"
+#include "mongo/db/pipeline/document_source/document_source_current_op.h"
 
 #include "mongo/db/pipeline/lite_parsed_document_source.h"
 
diff --git a/src/mongo/db/pipeline/document_source_current_op.h b/src/mongo/db/pipeline/document_source/document_source_current_op.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_current_op.h
rename to src/mongo/db/pipeline/document_source/document_source_current_op.h
index 49e0be6c35..7cdcf72d0c 100644
--- a/src/mongo/db/pipeline/document_source_current_op.h
+++ b/src/mongo/db/pipeline/document_source/document_source_current_op.h
@@ -29,7 +29,7 @@
 
 #pragma once
 
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 
 namespace mongo {
 
diff --git a/src/mongo/db/pipeline/document_source_current_op_test.cpp b/src/mongo/db/pipeline/document_source/document_source_current_op_test.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_current_op_test.cpp
rename to src/mongo/db/pipeline/document_source/document_source_current_op_test.cpp
index 260bfbf082..696ba0b4b8 100644
--- a/src/mongo/db/pipeline/document_source_current_op_test.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_current_op_test.cpp
@@ -32,7 +32,7 @@
 #include "mongo/db/exec/document_value/document.h"
 #include "mongo/db/exec/document_value/document_value_test_util.h"
 #include "mongo/db/pipeline/aggregation_context_fixture.h"
-#include "mongo/db/pipeline/document_source_current_op.h"
+#include "mongo/db/pipeline/document_source/document_source_current_op.h"
 #include "mongo/db/pipeline/process_interface/stub_mongo_process_interface.h"
 #include "mongo/unittest/unittest.h"
 #include "mongo/util/assert_util.h"
diff --git a/src/mongo/db/pipeline/document_source_cursor.cpp b/src/mongo/db/pipeline/document_source/document_source_cursor.cpp
similarity index 99%
rename from src/mongo/db/pipeline/document_source_cursor.cpp
rename to src/mongo/db/pipeline/document_source/document_source_cursor.cpp
index 023554a1be..aadae9f99c 100644
--- a/src/mongo/db/pipeline/document_source_cursor.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_cursor.cpp
@@ -31,7 +31,7 @@
 
 #include "mongo/platform/basic.h"
 
-#include "mongo/db/pipeline/document_source_cursor.h"
+#include "mongo/db/pipeline/document_source/document_source_cursor.h"
 
 #include "mongo/db/catalog/collection.h"
 #include "mongo/db/exec/document_value/document.h"
diff --git a/src/mongo/db/pipeline/document_source_cursor.h b/src/mongo/db/pipeline/document_source/document_source_cursor.h
similarity index 99%
rename from src/mongo/db/pipeline/document_source_cursor.h
rename to src/mongo/db/pipeline/document_source/document_source_cursor.h
index 2788946637..abe1618074 100644
--- a/src/mongo/db/pipeline/document_source_cursor.h
+++ b/src/mongo/db/pipeline/document_source/document_source_cursor.h
@@ -33,7 +33,7 @@
 
 #include "mongo/db/db_raii.h"
 #include "mongo/db/namespace_string.h"
-#include "mongo/db/pipeline/document_source.h"
+#include "mongo/db/pipeline/document_source/document_source.h"
 #include "mongo/db/query/explain_options.h"
 #include "mongo/db/query/plan_executor.h"
 #include "mongo/db/query/plan_summary_stats.h"
diff --git a/src/mongo/db/pipeline/document_source_densify.cpp b/src/mongo/db/pipeline/document_source/document_source_densify.cpp
similarity index 98%
rename from src/mongo/db/pipeline/document_source_densify.cpp
rename to src/mongo/db/pipeline/document_source/document_source_densify.cpp
index c7d8b122c3..8bed48f0ab 100644
--- a/src/mongo/db/pipeline/document_source_densify.cpp
+++ b/src/mongo/db/pipeline/document_source/document_source_densify.cpp
@@ -27,7 +27,7 @@
  *    it in the license file.
  */
 
-#include "mongo/db/pipeline/document_source_densify.h"
+#include "mongo/db/pipeline/document_source/document_source_densify.h"
 #include "mongo/util/visit_helper.h"
 namespace mongo {
 
